import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.io.*;
import javax.comm.*;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JButton;
import javax.swing.JSlider;
import java.awt.Choice;
import javax.swing.JTextField;
import javax.swing.JLabel;

public class Frame extends JFrame {

	static CommPortIdentifier portID;
	InputStream ins;
	OutputStream out;
	static SerialPort serss;
	
	long serialStart = 0;
	long serialEnd = 0;
	int lastState = 0;
	BufferedImage buffImg;
	ArrayList<Byte> arrayList;
	
	private JPanel jContentPane = null;
	private JScrollPane jScrollPane = null;
	private JTextArea jTextArea = null;
	private JButton jButton = null;
	private JPanel jPanel = null;
	byte[] temp_byte;
	private JSlider jSlider = null;
	private JSlider jSlider1 = null;
	private JPanel jPanel1 = null;
	private JPanel jPanel2 = null;
	private Choice choice = null;
	private JButton jButton1 = null;
	private JButton jButton2 = null;
	private JTextField jTextField = null;
	private JButton jButton3 = null;
	private JButton jButton4 = null;
	private JLabel jLabel = null;
	/**
	 * This is the default constructor
	 */
	public Frame() {
		super();
		initialize();
	}
	
	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jLabel = new JLabel();
			jLabel.setText("Samplerate: ");
			jPanel2 = new JPanel();
			jPanel2.add(getChoice(), null);
			jPanel2.add(getJButton(), null);
			jPanel2.add(getJButton1(), null);
			jPanel2.add(getJButton2(), null);
			jPanel2.add(getJTextField(), null);
			jPanel2.add(getJButton3(), null);
			jPanel2.add(getJButton4(), null);
			jPanel2.add(jLabel, null);
		}
		return jPanel2;
	}

	/**
	 * This method initializes choice	
	 * 	
	 * @return java.awt.Choice	
	 */
	private Choice getChoice() {
		if (choice == null) {
			choice = new Choice();
			for (int i = 0; i < 3; i++) {
				choice.add("COM"+(i+1));
			}
		}
		return choice;
	}
 
	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("Start Serial");
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public synchronized void actionPerformed(java.awt.event.ActionEvent e) {
					try{
						serialStart = 0;
						arrayList = new ArrayList<Byte>();
						portID = CommPortIdentifier.getPortIdentifier(choice.getSelectedItem());
						serss = (SerialPort) portID.open("Java_app",2000);
						ins = serss.getInputStream();
				        out = serss.getOutputStream();
				        				        
				        serss.setSerialPortParams(115200,
		                        SerialPort.DATABITS_8,
		                        SerialPort.STOPBITS_1 ,
		                        SerialPort.PARITY_NONE);
				        
				        wait(50);
				        
				        serss.notifyOnDataAvailable(true);
				        serss.addEventListener(new commListener());
				        
					}catch(Exception exc){
						UniversalDialog UD = new UniversalDialog("Error",exc.toString());
						UD.setVisible(true);
					}
				}			
						
				
			});
		}
		return jButton1;
	}

	/**
	 * This method initializes jButton2	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setText("Stop Serial");
			jButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (serss != null) {
						serialEnd = System.currentTimeMillis();
						serss.close();
						Iterator it = arrayList.iterator();
						int x = 0;
						
						if (arrayList.size()>jPanel.getWidth()) {
							temp_byte = new byte[arrayList.size()];
						}else{
							temp_byte = new byte[jPanel.getWidth()+1];
						}
						while (it.hasNext()) {
							temp_byte[x] = (Byte)it.next();
							x++;
						}
						
						double samplerate = Math.round(temp_byte.length/((serialEnd-serialStart)/1000.0));
						jLabel.setText("Samplerate: "+samplerate);
						
						jSlider.setValue(1);
						jSlider1.setValue(1);
						jSlider.setMaximum(temp_byte.length/jPanel.getWidth());
						jSlider1.setMaximum((temp_byte.length-(jPanel.getWidth()*jSlider.getValue())));
						
						offPaint();
						serss = null;
					}
				}
			});
		}
		return jButton2;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setPreferredSize(new java.awt.Dimension(150,20));
			jTextField.setToolTipText("Filename");
		}
		return jTextField;
	}

	/**
	 * This method initializes jButton3	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setText("Save");
			jButton3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						FileOutputStream fos = new FileOutputStream(jTextField.getText());
						fos.write(temp_byte);
						fos.close();
					} catch (FileNotFoundException e1) {
						UniversalDialog UD = new UniversalDialog("Error",e1.toString());
						UD.setVisible(true);
					} catch (IOException e2) {
						UniversalDialog UD = new UniversalDialog("Error",e2.toString());
						UD.setVisible(true);
					}
				}
			});
		}
		return jButton3;
	}

	/**
	 * This method initializes jButton4	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton4() {
		if (jButton4 == null) {
			jButton4 = new JButton();
			jButton4.setText("Load");
			jButton4.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						FileInputStream fis = new FileInputStream(jTextField.getText());
						if (fis.available()>0) {
							temp_byte = new byte[fis.available()];
							fis.read(temp_byte);
						}
						fis.close();
						jSlider.setValue(1);
						jSlider1.setValue(1);
						jSlider.setMaximum(temp_byte.length/jPanel.getWidth());
						jSlider1.setMaximum((temp_byte.length-(jPanel.getWidth()*jSlider.getValue())));
						repaint();
					} catch (FileNotFoundException e1) {
						UniversalDialog UD = new UniversalDialog("Error",e1.toString());
						UD.setVisible(true);
					} catch (IOException e2) {
						UniversalDialog UD = new UniversalDialog("Error",e2.toString());
						UD.setVisible(true);
					}
				}
			});
		}
		return jButton4;
	}

	public static void main(String[] args){
		Frame frame = new Frame();
		frame.setVisible(true);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(884, 498);
		this.setContentPane(getJContentPane());
		this.setTitle("Simple Scope");
		this.setResizable(false);
		this.addComponentListener(new java.awt.event.ComponentAdapter() {
			public void componentResized(java.awt.event.ComponentEvent e) {
				repaint();
			}
		});
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJScrollPane(), java.awt.BorderLayout.WEST);
			jContentPane.add(getJPanel1(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getJPanel2(), java.awt.BorderLayout.NORTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextArea());
			jScrollPane.setPreferredSize(new Dimension(this.getWidth(),this.getHeight()));
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
		}
		return jTextArea;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("FromTextField");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					StringTokenizer string_tok = new StringTokenizer(jTextArea.getText());
					String[] temp_string = new String[string_tok.countTokens()];
					if (temp_string.length<jPanel.getWidth()) {
						temp_byte = new byte[jPanel.getWidth()+1];
					}else{
						temp_byte = new byte[temp_string.length];
					}
					
					int x = 0;
					while (string_tok.hasMoreElements()) {
						String element = (String) string_tok.nextElement();
						temp_string[x] = element;
						x++;
					}
					for (int i = 0; i < x; i++) {
						temp_byte[i]=(byte)(Integer.parseInt(temp_string[i]));
					}
					
					jSlider.setMaximum(temp_byte.length/jPanel.getWidth());
					jSlider1.setMaximum((temp_byte.length-(jPanel.getWidth())));
					jSlider.setValue(1);
					jSlider1.setValue(1);
					//System.out.println("1: Min: "+jSlider.getMinimum()+" Max: "+jSlider.getMaximum()+" Val: "+jSlider.getValue());
					//System.out.println("2: Min: "+jSlider1.getMinimum()+" Max: "+jSlider1.getMaximum()+" Val: "+jSlider1.getValue());
					offPaint();
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setPreferredSize(new Dimension(400,255));
		}
		return jPanel;
	}
	
	public void paint(Graphics g){
		super.paint(g);
		jPanel.getGraphics().fillRect(0,0,jPanel.getWidth(),255);
		jPanel.getGraphics().drawImage(buffImg,0,0,this);
	}
	
	private void offPaint(){
		if (temp_byte!=null) {
			if (buffImg == null) {
				buffImg = new BufferedImage(jPanel.getWidth(),255,BufferedImage.TYPE_BYTE_INDEXED);
			}
			Graphics gp = buffImg.getGraphics();
			gp.setColor(Color.BLACK);
			gp.fillRect(0,0,jPanel.getWidth(),255);
			gp.setColor(Color.WHITE);
			int lastX =0;
			int lastY =0;
			int x = 0;
			int y = 0;
			int zoom = jSlider.getValue();
			int int1 = jSlider1.getValue(); 
			int int2 = jPanel.getWidth()*jSlider.getValue();
			for (int i = int1; i < int1+int2 ; i++) {				
				x = (int)((i-int1)/zoom);
				if (temp_byte[i]>=0) {
					y = Math.abs(temp_byte[i]);
					gp.drawLine(lastX,lastY,x,y);
					lastY = y;
				}else{
					y = 255-Math.abs(temp_byte[i]);
					gp.drawLine(lastX,lastY,x,y);
					lastY = y;
				}
				lastX = x;
			}
		}
		repaint();
	}

	/**
	 * This method initializes jSlider	
	 * 	
	 * @return javax.swing.JSlider	
	 */	
	private JSlider getJSlider() {
		if (jSlider == null) {
			jSlider = new JSlider();
			jSlider.setMinimum(1);
			jSlider.setMaximum(100);
			jSlider.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (temp_byte != null) {
						jSlider1.setMaximum((temp_byte.length-(jPanel.getWidth()*jSlider.getValue())));
						offPaint();			
					}
					
				}
			});
		}
		return jSlider;
	}

	/**
	 * This method initializes jSlider1	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSlider1() {
		if (jSlider1 == null) {
			jSlider1 = new JSlider();
			jSlider1.setMinimum(1);
			jSlider1.setMaximum(1);
			jSlider1.setValue(1);
			jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (temp_byte != null) {
						if (Math.abs(lastState-jSlider1.getValue())>(temp_byte.length/100)*(0.1+(jSlider.getValue()/50.0))) {
							offPaint();
							lastState = jSlider1.getValue();
						}
					}
				}
			});
		}
		return jSlider1;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(new BorderLayout());
			jPanel1.add(getJPanel(), java.awt.BorderLayout.CENTER);
			jPanel1.add(getJSlider(), java.awt.BorderLayout.NORTH);
			jPanel1.add(getJSlider1(), java.awt.BorderLayout.SOUTH);
		}
		return jPanel1;
	}
	
	public class commListener implements SerialPortEventListener{
	    public void serialEvent(SerialPortEvent event) {
	      if(event.getEventType()==SerialPortEvent.DATA_AVAILABLE){
	    	  if (serialStart==0) {
				serialStart = System.currentTimeMillis();
	    	  }
	    	  byte[] readBuffer = new byte[100];
	    	  try {
	        	int numBytes = 0; 
	        	while (ins.available() > 0) {
	        		numBytes = ins.read(readBuffer);
	        	}
	        	for (int i = 0; i < numBytes; i++) {
	        		arrayList.add(readBuffer[i]);
	        	}
	          
	        }
	        catch (IOException e) {
	        	//Ignore
	        }
	      }
	    }
	  }

}  //  @jve:decl-index=0:visual-constraint="10,10"


